#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/wait.h>
#include <string.h>
#include <sys/stat.h>

int solo;
int delay = 30;
int minidelay = 10;
int maxgames = 15;

int dontplay[1024];
int dontplay_size;

int nopass;
int bip;

char *logdir;
char *user, *pass, *dict;

void glog(int game, char *t, char *lastline, char *s)
{
  FILE *f;
  char ff[1024];
  if (!logdir) return;
  sprintf(ff, "%s/%d", logdir, game);
  f = fopen(ff, "a"); if (!f) { perror(ff); exit(1); }
  fprintf(f, "%s %s %s\n", t, lastline, s);
  fclose(f);
}

void do_bip(char *m)
{
  char t[256];
  if (!bip) return;
  sprintf(t, "aplay %s", m);
  system(t);
}

void run(char *s)
{
printf("running: %s\n", s);
  int son;
  int status;
  son = fork(); if (son == -1) abort();
  if (!son) {
    execlp("/bin/sh", "/bin/sh", "-c", s, NULL);
    exit(1);
  }
  if (wait(&status) == -1) abort();
}

void get_messages(void)
{
  struct stat b;
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -lm > bot.log", user, pass);
  run(s);
  if (stat("bot.log", &b)) abort();
  if (b.st_size) do_bip("message.wav");
}

void get_invitations(void)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -li > bot.log", user, pass);
  run(s);
}

void accept(int game)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -ai %d", user, pass, game);
  run(s);
}

void get_games(void)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -lg > bot.log", user, pass);
  run(s);
}

void get_game(int g)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -sg %d > botgame.log", user, pass, g);
  run(s);
}

void endlog(void)
{
  FILE *f;
  char s[512];
  unlink("bot.log");
  sprintf(s, "kelimelik -u %s -p %s -stats -bot > bot.log", user, pass);
  run(s);
  f = fopen("bot.log", "r"); if (!f) abort();
  while (1) {
    struct stat b;
    int g;
    if (fscanf(f, "%d", &g) != 1) break;
    sprintf(s, "%s/%d.over", logdir, g);
    if (!stat(s, &b)) continue;
    unlink("botgame.log");
    get_game(g);
    if (rename("botgame.log", s)) abort();
  }
  fclose(f);
}

void play(int g)
{
  int i;
  char s[256];
  char t[512];
  char lastline[1024];
  FILE *f;
  FILE *o;

  for (i = 0; i < dontplay_size; i++)
    if (g == dontplay[i]) { printf("not playing %d\n", g); return; }

  if (logdir) {
    struct stat b;
    sprintf(t, "%s/%d.start", logdir, g);
    if (stat(t, &b)) {
      sprintf(t, "cp botgame.log %s/%d.start", logdir, g);
      if (system(t)) abort();
    }
  }

  f = fopen("botgame.log", "r"); if (!f) abort();
  o = fopen("GAME", "w"); if (!o) abort();
  for (i = 0; i < 15;) {
    int c = fgetc(f); if (c == EOF) abort(); if (c == '\n') i++;
    fputc(c, o);
  }
  if (fclose(o)) abort();
  o = fopen("VALUE", "w"); if (!o) abort();
  for (i = 0; i < 15;) {
    int c = fgetc(f); if (c == EOF) abort(); if (c == '\n') i++;
    fputc(c, o);
  }
  if (fclose(o)) abort();
  for (i = 0; ; i++) {
    int c = fgetc(f); if (c == EOF) abort(); if (c == '\n') break;
    s[i] = c;
  }
  s[i] = 0;
  for (i = 0; i < 1023; i++)
    { int c = fgetc(f); if (c == EOF || c == '\n') break; lastline[i] = c; }
  lastline[i] = 0;
  fclose(f);
  sprintf(t, "scrabble -kdist -kbot -kelimelik -value VALUE %s GAME %s"
             " | sort -nr | cut -f 2 -d : > SCORE", dict, s);
  run(t);

  f = fopen("SCORE", "r"); if (!f) abort();
next_try:
  i = 0;
  while (1) {
    int c = fgetc(f); if (c == EOF || c == '\n') break;
    s[i] = c; i++;
  }
  if (!i) goto no_word;
  s[i] = 0;
  sprintf(t, "kelimelik -bot -u %s -p %s -play %d %s > RUN", user, pass, g, s);
  run(t);
  o = fopen("RUN", "r"); if (!o) abort(); i = fgetc(o); fclose(o);
  i -= '0';
  if (!i) goto next_try;
  fclose(f);
  if (i == 1) glog(g, "T", lastline, s);
  printf("mini sleep\n");
  sleep(minidelay);
  return;

no_word:
  fclose(f);
  glog(g, "P", lastline, "");
  if (bip) do_bip("pass.wav");
  if (nopass) { printf("no word, should pass!\n"); return; }
  sprintf(t, "kelimelik -bot -u %s -p %s -pass %d", user, pass, g);
  run(t);
  printf("mini sleep\n");
  sleep(minidelay);
}

void new_game(void)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -irf", user, pass);
  run(s);
}

char *l;
int lsize;
int lmaxsize;
FILE *f;

void resetline(void)
{
  if (f) fclose(f);
  f = fopen("bot.log", "r"); if (!f) f = fopen("/dev/null", "r");
}

void put(char c)
{
  if (lsize == lmaxsize) { l = realloc(l, lmaxsize+=256); if (!l) abort(); }
  l[lsize++] = c;
}

char *get_line(void)
{
  lsize = 0;
  while (1) {
    int c = fgetc(f); if (c == EOF || c == '\n') break;
    put(c);
  }
  if (!lsize) return 0;
  put(0);
  return l;
}

void usage(void)
{
  printf("bot [options] <mail> <pass> <dict>\n");
  printf("options:\n");
  printf("    -nopass\n");
  printf("        don't pass if no word\n");
  printf("    -bip\n");
  printf("        don't pass, don't accept invitations\n");
  printf("        plays 'message.wav' if unread messages are there\n");
  printf("        plays 'pass.wav' if you have to pass\n");
  printf("        plays 'invit.wav' if invitations waiting\n");
  printf("    -noplay <game ID>\n");
  printf("        don't play given game (may be used multiple times)\n");
  printf("    -log <log directory>\n");
  printf("        log games into given directory\n");
  printf("    -delay <delay in seconds>\n");
  printf("        wait for given time between each round, default 30s\n");
  printf("    -minidelay <delay in seconds>\n");
  printf("        wait for given time between each play, default 10s\n");
  printf("    -solo <game ID>\n");
  printf("        only plays given game\n");
  printf("    -maxgames <number of games (default 15)>\n");
  printf("        plays at most given number of games at the same time\n");
  exit(1);
}

int main(int n, char **v)
{
  int i;
  char *l;
  int playing[1024];
  int ready[1024];
  int ready_size = 0;
  int playing_size = 0;

  for (i = 1; i < n; i++) {
    if (!strcmp(v[i], "-nopass")) { nopass = 1; continue; }
    if (!strcmp(v[i], "-bip")) { bip = 1; nopass = 1; continue; }
    if (!strcmp(v[i], "-noplay"))
      {if (i > n - 2) usage(); if (dontplay_size == 1024) abort();
       dontplay[dontplay_size] = atoi(v[++i]); dontplay_size++; }
    if (!strcmp(v[i], "-log"))
      {if (i > n - 2) usage(); logdir = v[++i]; continue; }
    if (!strcmp(v[i], "-delay"))
      {if (i > n - 2) usage(); delay = atoi(v[++i]); continue; }
    if (!strcmp(v[i], "-minidelay"))
      {if (i > n - 2) usage(); minidelay = atoi(v[++i]); continue; }
    if (!strcmp(v[i], "-solo"))
      {if (i > n - 2) usage(); solo = atoi(v[++i]); continue; }
    if (!strcmp(v[i], "-maxgames"))
      {if (i > n - 2) usage(); maxgames = atoi(v[++i]); continue; }
    if (!user) { user = v[i]; continue; }
    if (!pass) { pass = v[i]; continue; }
    if (!dict) { dict = v[i]; continue; }
    usage();
  }
  if (!user || !pass || !dict) usage();

  while (1) {
    if (logdir) endlog();
    unlink("bot.log");
    get_messages();
    unlink("bot.log");
    get_invitations();
    resetline();
    for (i = 0; ; i++) {
      int user_id;
      if (!(l=get_line())) break;
      if (sscanf(l, "%d", &user_id) != 1) abort();
      if (!bip) accept(user_id);
      if (i == 0 && bip) do_bip("invit.wav");
    }
    unlink("bot.log");
    get_games();
    resetline();
    for (i = 0; ; i++) {
      int j;
      int game, me;
      if (!(l=get_line())) break;
      if (sscanf(l, "%d %d", &game, &me) != 2) abort();
      if (!me) continue;
      if (ready_size == 1024) abort();
      for (j = 0; j < playing_size; j++) if (playing[j] == game) break;
      if (j == playing_size) { ready[ready_size] = game; ready_size++; }
    }
    if (i < maxgames) new_game();
    for (i = 0; i < playing_size; i++) {
      int game = playing[i];
      unlink("botgame.log");
      if (solo && game != solo) continue;
      get_game(game);
      play(game);
    }
    printf("sleep\n");
    sleep(delay);
    for (i = 0; i < ready_size; i++) playing[i] = ready[i];
    playing_size = ready_size;
    ready_size = 0;
  }

  return 0;
}
