#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/wait.h>
#include <string.h>

int nopass;

char *user, *pass, *dict;

int game;

void run(char *s)
{
printf("running: %s\n", s);
  int son;
  int status;
  son = fork(); if (son == -1) abort();
  if (!son) {
    execlp("/bin/sh", "/bin/sh", "-c", s, NULL);
    exit(1);
  }
  if (wait(&status) == -1) abort();
}

void get_invitations(void)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -li > bot.log", user, pass);
  run(s);
}

void accept(int game)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -ai %d", user, pass, game);
  run(s);
}

void get_games(void)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -lg > bot.log", user, pass);
  run(s);
}

void get_game(int g)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -sg %d > botgame.log", user, pass, g);
  run(s);
}

void play(int g)
{
  int i;
  char s[256];
  char t[512];
  FILE *f = fopen("botgame.log", "r"); if (!f) abort();
  FILE *o = fopen("GAME", "w"); if (!o) abort();
  for (i = 0; i < 15;) {
    int c = fgetc(f); if (c == EOF) abort(); if (c == '\n') i++;
    fputc(c, o);
  }
  if (fclose(o)) abort();
  o = fopen("VALUE", "w"); if (!o) abort();
  for (i = 0; i < 15;) {
    int c = fgetc(f); if (c == EOF) abort(); if (c == '\n') i++;
    fputc(c, o);
  }
  if (fclose(o)) abort();
  for (i = 0; ; i++) {
    int c = fgetc(f); if (c == EOF) abort(); if (c == '\n') break;
    s[i] = c;
  }
  s[i] = 0;
  fclose(f);
  sprintf(t, "scrabble -kbot -kelimelik -value VALUE %s GAME %s"
             " | sort -nr | cut -f 2 -d : > SCORE", dict, s);
  run(t);

  f = fopen("SCORE", "r"); if (!f) abort();
next_try:
  i = 0;
  while (1) {
    int c = fgetc(f); if (c == EOF || c == '\n') break;
    s[i] = c; i++;
  }
  if (!i) goto no_word;
  s[i] = 0;
  sprintf(t, "kelimelik -bot -u %s -p %s -play %d %s > RUN", user, pass, g, s);
  run(t);
  o = fopen("RUN", "r"); if (!o) abort(); i = fgetc(o); fclose(o);
  i -= '0';
  if (!i) goto next_try;
  fclose(f);
  return;

no_word:
  fclose(f);
  if (nopass) { printf("no word, should pass!\n"); return; }
  sprintf(t, "kelimelik -bot -u %s -p %s -pass %d", user, pass, g);
  run(t);
}

void new_game(void)
{
  char s[512];
  sprintf(s, "kelimelik -u %s -p %s -bot -irf", user, pass);
  run(s);
}

char *l;
int lsize;
int lmaxsize;
FILE *f;

void resetline(void)
{
  if (f) fclose(f);
  f = fopen("bot.log", "r"); if (!f) f = fopen("/dev/null", "r");
}

void put(char c)
{
  if (lsize == lmaxsize) { l = realloc(l, lmaxsize+=256); if (!l) abort(); }
  l[lsize++] = c;
}

char *get_line(void)
{
  lsize = 0;
  while (1) {
    int c = fgetc(f); if (c == EOF || c == '\n') break;
    put(c);
  }
  if (!lsize) return 0;
  put(0);
  return l;
}

void usage(void)
{
  printf("bot1 [options] <mail> <pass> <dict> <game>\n");
  printf("options:\n");
  printf("    -nopass\n");
  printf("        don't pass if no word\n");
  exit(1);
}

int main(int n, char **v)
{
printf("deprecated program\n"); return 1;
  int i;
  char *l;
  char *sgame = NULL;

  for (i = 1; i < n; i++) {
    if (!strcmp(v[i], "-nopass")) { nopass = 1; continue; }
    if (!user) { user = v[i]; continue; }
    if (!pass) { pass = v[i]; continue; }
    if (!dict) { dict = v[i]; continue; }
    if (!sgame) { sgame = v[i]; continue; }
    usage();
  }
  if (!user || !pass || !dict || !sgame) usage();
  game = atoi(sgame);

  while (1) {
    unlink("bot.log");
    get_games();
    resetline();
    for (i = 0; ; i++) {
      int gme, me;
      if (!(l=get_line())) break;
      if (sscanf(l, "%d %d", &gme, &me) != 2) abort();
      if (!me) continue;
      if (gme == game) get_game(gme);
      if (gme == game) play(gme);
    }
    //if (i < 5) new_game();
    printf("sleep\n");
    sleep(10);
  }

  return 0;
}
