#include <stdio.h>
#include <cairo/cairo.h>
#include <cairo/cairo-xlib.h>
#include <X11/Xlib.h>
#include <stdlib.h>

int main(void)
{
  cairo_surface_t *image;
  cairo_pattern_t *pletters;
  cairo_surface_t *cs;
  Display *d;
  Pixmap p;

  d = XOpenDisplay(0); if (!d) abort();
  p = XCreatePixmap(d, DefaultRootWindow(d), 256, 256,
                    DefaultDepth(d, DefaultScreen(d)));
  cs = cairo_xlib_surface_create(d, p, DefaultVisual(d, DefaultScreen(d)),
                                 256, 256);

  //image = cairo_image_surface_create(CAIRO_FORMAT_ARGB32, 512, 512);
  image = cairo_image_surface_create_from_png("mini.png");
  pletters = cairo_pattern_create_for_surface(image);

  int y;
  for (y=0; y < 500; y++) {
    int i;
    cairo_matrix_t m;
    cairo_t *c = cairo_create(cs);

    //cairo_scale(c, 0.5, 0.5);
    //cairo_translate(c, 1, 1);
    for (i = 0; i < 15; i++) {
      //static int z = 2;  cairo_matrix_init_translate(&m, 0, 0); //z = 2 - z;
      cairo_matrix_init_translate(&m, 0, 0); //z = 2 - z;
      cairo_pattern_set_matrix(pletters, &m);
      cairo_set_source(c, pletters);
      cairo_paint(c);

      //XSync(d, True);
      printf("%d evs\n", XEventsQueued(d, QueuedAfterReading));
      XFlush(d);

      while (XPending(d)) { XEvent ev; XNextEvent(d, &ev); printf("event!\n"); }
    }

    cairo_destroy(c);
  }

  return 0;
}
