#ifndef _KELIMELIK_H_
#define _KELIMELIK_H_

#include "utils.h"

typedef struct {
  int board[15*15];
  int game_id;
  int opponent_id;
} game;

#define USER_ID_SET               0x00001
#define LOGGED_IN                 0x00002
#define GAME_LIST_OK              0x00004
#define GAME_OK                   0x00008
#define MESSAGES_OK               0x00010
#define WORD_OK                   0x00020
#define WORD_NOOK                 0x00040
#define NEW_TURN                  0x00080
#define COMPLETED_GAME_LIST_OK    0x00100
#define INVITATIONS_OK            0x00200
#define USER_PROFILE_OK           0x00400

struct mess;

typedef struct {
  lockwait lock;
  char *server;
  int port;
  char *email;
  char *pass;
  int user_id;
  struct mess *game_list_mess;
  struct mess *completed_game_list_mess;
  struct mess *game;
  struct mess *messages;
  struct mess *invit;
  struct mess *user;
  volatile unsigned flags;
} kelimelik;

#endif /* _KELIMELIK_H_ */
