#include <stdio.h>
#include <execinfo.h>
#include <dlfcn.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>

static Bool (*libx_XShmAttach)(
            Display *display,
            XShmSegmentInfo *shminfo);

static Bool (*libx_XShmDetach)(
            Display *display,
            XShmSegmentInfo *shminfo);

static void dainit(void)
{
  static int init = 0;
  if (init) return;
  init = 1;
  void *t = dlopen("/usr/lib/x86_64-linux-gnu/libXext.so.6", RTLD_LAZY); if (!t)abort();
  libx_XShmAttach = dlsym(t, "XShmAttach");
  if (!libx_XShmAttach) abort();
  libx_XShmDetach = dlsym(t, "XShmDetach");
  if (!libx_XShmDetach) abort();
}

Bool XShmAttach(
            Display *display,
            XShmSegmentInfo *shminfo)
{
  dainit();
  printf("XShmAttach\n");
  return libx_XShmAttach(display, shminfo);
}

Bool XShmDetach(
            Display *display,
            XShmSegmentInfo *shminfo)
{
  dainit();
  printf("  XShmDetach\n");
  return libx_XShmDetach(display, shminfo);
}

