#ifndef _MESS_H_
#define _MESS_H_

#include <stdint.h>

typedef enum {
  STRING, INT, DATE, ARRAY, UNKNOWN_1, UNKNOWN_3
} arg_type;

struct arg;

typedef struct {
  arg_type type;
  struct arg *l;
  int size;
} array;

typedef struct arg {
  arg_type type;
  union {
    char *s;
    int i;
    uint64_t d;
    array *a;
  };
} arg;

typedef struct mess {
  char *fun;
  arg *args;
  int args_size;
} mess;

array *new_array(arg_type);
void array_arg_string(array *, char *);
void array_arg_int(array *, int);

mess *new_mess(char *);
void mess_arg_string(mess *, char *);
void mess_arg_int(mess *, int);

void free_mess(mess *);

char *mess_serialize(mess *, int *);
mess *mess_unserialize(char *, int);

void print_mess(mess *);

int check_mess(mess *, int, ...);

#endif /* _MESS_H_ */
