#ifndef _UTILS_H_
#define _UTILS_H_

extern char *vraw;
extern int verbose;

#define log(...) do { if (verbose) printf(__VA_ARTS__); } while (0)

typedef struct {
  void *mutex;
  void *cond;
} lockwait;

void lw_init(lockwait *);
void lw_lock(lockwait *);
void lw_unlock(lockwait *);
void lw_wait(lockwait *);
void lw_wakeup(lockwait *);

void new_thread(void *(*f)(void *), void *data);

typedef struct queue_item {
  void *data;
  struct queue_item *prev;
} queue_item;

typedef struct {
  lockwait l;
  /* I am getting lost with volatiles. The idea is to force wait_dequeue
   * to read q->tail every time, without caching values because it is
   * changed by other threads. Is the declaration below forcing that?
   */
  queue_item * volatile head, * volatile tail;
} queue;

void init_queue(queue *);
void *wait_dequeue(queue *);
void enqueue(queue *, void *);

#endif /* _UTILS_H_ */
